#include<stdio.h>
#include<math.h>
#include"calculation.h"

void Euler(double (*f[])(double t, double *x), double t0, double *x, double tn, int div, int num)
{
	double h, t;
	double *temp;
	int i, j;

	if((temp = (double*)malloc(sizeof(double)*num)) == NULL){
		fprintf(stderr, "Allocation Error\n");
		exit(1);
	}

	h = (tn - t0);
	if(div) h /= div;

	t = t0;

	for(i=0; i<div; i++){
		for(j=0; j<num; j++){
			temp[j] = h*(*f[j])(t, x);
		}

		for(j=0; j<num; j++){
			x[j] += temp[j];
		}
		t += h;
	}

	free(temp);
}

